; ---------------------------------------------------------------------------

ObjAnimationTest:                       ; DATA XREF: ROM:000085B0↑o
        moveq   #0,d0
        move.b  $24(a0),d0
        move.w  ObjAniTest_Index(pc,d0.w),d1
        jmp     ObjAniTest_Index(pc,d1.w)
; ---------------------------------------------------------------------------
ObjAniTest_Index:
        dc.w ObjAniTest_Init-ObjAniTest_Index ; CODE XREF: ROM:000111CC↑j
        dc.w ObjAniTest_Display-ObjAniTest_Index
        dc.w ObjAniTest_Delete-ObjAniTest_Index
        dc.w ObjAniTest_Delete-ObjAniTest_Index
; ---------------------------------------------------------------------------

ObjAniTest_Init:                        ; DATA XREF: ROM:ObjAniTest_Index↑o
        addq.b  #2,$24(a0)
        move.b  #$12,$16(a0)
        move.b  #9,$17(a0)
        move.l  #Map_Sonic,4(a0)
        move.w  #$780,2(a0)
        move.b  #4,1(a0)
        move.b  #2,$19(a0)

ObjAniTest_Display:                     ; DATA XREF: ROM:000111D2↑o
        bsr.w   ObjAniTest_Control
        jsr   LoadSonicDynPLC
        jmp	DisplaySprite

; =============== S U B R O U T I N E =======================================

ObjAniTest_Control:                     ; CODE XREF: ROM:ObjAniTest_Display↑p
        move.b  ($FFFFF602).w,d4
        move.w  $C(a0),d2
        move.w  8(a0),d3
        moveq   #1,d1
        btst    #0,d4
        beq.s   ObjAniTest_ChkDown
        sub.w   d1,d2

ObjAniTest_ChkDown:                     ; CODE XREF: ObjAniTest_Control+12↑j
        btst    #1,d4
        beq.s   ObjAniTest_ChkLeft
        add.w   d1,d2

ObjAniTest_ChkLeft:                     ; CODE XREF: ObjAniTest_Control+1A↑j
        btst    #2,d4
        beq.s   ObjAniTest_ChkRight
        sub.w   d1,d3

ObjAniTest_ChkRight:                    ; CODE XREF: ObjAniTest_Control+22↑j
        btst    #3,d4
        beq.s   ObjAniTest_ChkB
        add.w   d1,d3

ObjAniTest_ChkB:                        ; CODE XREF: ObjAniTest_Control+2A↑j
        move.w  d2,$C(a0)
        move.w  d3,8(a0)
        btst    #4,($FFFFF603).w
        beq.s   ObjAniTest_ChkC
        move.b  1(a0),d0
        move.b  d0,d1
        addq.b  #1,d0
        andi.b  #3,d0
        andi.b  #$FC,d1
        or.b    d1,d0
        move.b  d0,1(a0)

ObjAniTest_ChkC:                        ; CODE XREF: ObjAniTest_Control+3C↑j
        btst    #5,($FFFFF603).w
        beq.s   ObjAniTest_Animate
        addq.b  #1,$1C(a0)
        cmpi.b  #$19,$1C(a0)
        bcs.s   ObjAniTest_Animate
        move.b  #0,$1C(a0)

ObjAniTest_Animate:                     ; CODE XREF: ObjAniTest_Control+5A↑j
        jsr     Sonic_Animate
        rts
; End of function ObjAniTest_Control

; ---------------------------------------------------------------------------

ObjAniTest_Delete:                      ; DATA XREF: ROM:000111D4↑o
        jmp     DeleteObject
; ---------------------------------------------------------------------------